<?php
/**
 * Ticket data template.
 *
 * @link https://www.fooevents.com
 * @package fooevents-express-check-in
 */

?>
<tr>
	<td><strong><a class="row-title" href="<?php echo esc_url( admin_url() ); ?>post.php?post=<?php echo esc_attr( $ticket->ID ); ?>&action=edit" aria-label="<?php echo esc_attr( $ticket->post_title ); ?> (Edit)" target="_BLANK"><?php echo esc_attr( $ticket->post_title ); ?></a></strong></td>
	<td><strong><a class="row-title" href="<?php echo esc_url( admin_url() ); ?>post.php?post=<?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsOrderID', true ) ); ?>&action=edit" aria-label="<?php echo esc_attr( $ticket->post_title ); ?> (Edit)" target="_BLANK"><?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsOrderID', true ) ); ?></a></strong></td>
	<td><span class="fooevents-express-check-in-mobile"><?php echo esc_attr__( 'Purchaser', 'fooevents-express-check-in' ); ?>: </span><?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsPurchaserFirstName', true ) ); ?> <?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsPurchaserLastName', true ) ); ?> </td>
	<td><span class="fooevents-express-check-in-mobile"><?php echo esc_attr__( 'Attendee', 'fooevents-express-check-in' ); ?>: </span><?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsAttendeeName', true ) ); ?> <?php echo esc_attr( get_post_meta( $ticket->ID, 'WooCommerceEventsAttendeeLastName', true ) ); ?></td>
	<td><span class="fooevents-express-check-in-event-name"><?php echo( ! empty( $event->post_title ) ) ? esc_attr( $event->post_title ) : ''; ?></span></td>
	<td>
		<?php if ( is_array( $ticket_variations ) ) : ?>
			<?php foreach ( $ticket_variations as $variation_name => $variation_value ) : ?>
				<b><?php echo esc_attr( $variation_name ); ?></b>: <?php echo esc_attr( $variation_value ); ?><br />
			<?php endforeach; ?>
		<?php endif; ?>
	</td>
	<?php if ( $bookings_enabled ) : ?>
	<td>
		<?php if ( ! empty( $bookings_data ) ) : ?>
			<?php echo esc_attr( $bookings_data['WooCommerceEventsBookingsSlotTerm'] ); ?>: <?php echo esc_attr( $bookings_data['WooCommerceEventsBookingSlot'] ); ?> <br />
			<?php echo esc_attr( $bookings_data['WooCommerceEventsBookingsDateTerm'] ); ?>: <?php echo esc_attr( $bookings_data['WooCommerceEventsBookingDate'] ); ?> 
		<?php endif; ?>
	</td>
	<?php endif; ?>
	<td><span id="fooevents-express-check-in-status-<?php echo esc_attr( $ticket->ID ); ?>" class="fooevents-express-check-in-status fooevents-express-check-in-status-<?php echo esc_attr( $ticket_status_class ); ?>"><?php echo wp_kses_post( $ticket_status ); ?></span></td>
	<td class="fooevents-express-check-in-button-td"><button id="fooevents-express-check-in-cancel-<?php echo esc_attr( $ticket->ID ); ?>" class="button button-secondary fooevents-express-check-in-control fooevents-express-check-in-cancel"><?php echo esc_attr__( 'Cancel', 'fooevents-express-check-in' ); ?></button></td>
	<td class="fooevents-express-check-in-button-td"><button id="fooevents-express-check-in-reset-<?php echo esc_attr( $ticket->ID ); ?>" class="button fooevents-express-check-in-control fooevents-express-check-in-reset">Reset</button></td>
	<td class="fooevents-express-check-in-button-td"><button id="fooevents-express-check-in-confirm-<?php echo esc_attr( $ticket->ID ); ?>" class="button <?php echo ( 'Checked In' !== $ticket_status ) ? 'button-primary' : ''; ?>  fooevents-express-check-in-control fooevents-express-check-in-confirm"><?php echo esc_attr__( 'Confirm', 'fooevents-express-check-in' ); ?></button></td>
</tr>
